Codeforces Round #537 (Div. 2)解題報告
第一題:(模擬)
#include<iostream>
#include<cstring>
#include<cmath>
#include<cstdio>
using namespace std;
#define debug puts("YES");
#define rep(x,y,z) for(int (x)=(y);(x)<(z);(x)++)
#define ll long long
#define lrt int l,int r,int rt
#define lson l,mid,rt<<1
#define rson mid+1,r,rt<<1|1
#define root l,r,rt
#define mst(a,b) memset((a),(b),sizeof(a))
#define pii pair<ll,ll>
#define mk(x,y) make_pair(x,y)
const int mod=998244353;
const int ub=1e6;
ll powmod(ll x,ll y){ll t; for(t=1;y;y>>=1,x=x*x%mod) if(y&1) t=t*x%mod; return t;}
ll gcd(ll x,ll y){return y?gcd(y,x%y):x;}
int vis[26];
string s1,s2;
int main()
{
vis['a'-'a']=1;
vis['e'-'a']=1;
vis['i'-'a']=1;
vis['o'-'a']=1;
vis['u'-'a']=1;
cin>>s1>>s2;
int len1=s1.size(),len2=s2.size();
if(len1!=len2) puts("No");
else{
int flag=0;
rep(i,0,len1){
if(vis[s1[i]-'a']!=vis[s2[i]-'a']) {flag=1;break;}
}
if(flag) puts("No");
else puts("Yes");
}
return 0;
}
第二題:(貪心)
#include<bits/stdc++.h>
using namespace std;
#define debug puts("YES");
#define rep(x,y,z) for(int (x)=(y);(x)<(z);(x)++)
#define ll long long
#define lrt int l,int r,int rt
#define lson l,mid,rt<<1
#define rson mid+1,r,rt<<1|1
#define root l,r,rt
#define mst(a,b) memset((a),(b),sizeof(a))
#define pii pair<ll,ll>
#define mk(x,y) make_pair(x,y)
const int maxn=1e5+9;
const int mod=998244353;
const int ub=1e6;
ll powmod(ll x,ll y){ll t; for(t=1;y;y>>=1,x=x*x%mod) if(y&1) t=t*x%mod; return t;}
ll gcd(ll x,ll y){return y?gcd(y,x%y):x;}
/*
題目大意:給定一個長度為n的序列,要求可以執行m次操作,
每次操作可以把一個人的權值加一,可以刪除一個人(如果刪除後人數不為空),
但每個人增長的權值最大值為k,問執行操作後其序列平均值是多少。
題目分析:貪心,假設刪除了x次,增長了y次,
其刪除的肯定是數值最小的,所以把原陣列排個序,然後列舉刪除的次數即可。
時間複雜度:O(n).
*/
ll a[maxn];
ll sum[maxn];
ll n,k,m;
int main()
{
cin>>n>>k>>m;
sum[0]=0LL;
for(int i=1;i<=n;i++) cin>>a[i];
sort(a+1,a+n+1);
rep(i,1,n+1) sum[i]=sum[i-1]+a[i];
double ans=1.0*sum[n]/n;
rep(i,0,n) if(i<=m){
int tm=m-i;
ans=max(ans,1.0*(sum[n]-sum[i]+1.0*min(1LL*tm,(n-i)*k))/(n-i));
}
else break;
printf("%.7f\n",ans);
return 0;
}
第三題:(分治)
#include<bits/stdc++.h>
using namespace std;
#define debug puts("YES");
#define rep(x,y,z) for(int (x)=(y);(x)<(z);(x)++)
#define ll long long
#define lrt int l,int r,int rt
#define lson l,mid,rt<<1
#define rson mid+1,r,rt<<1|1
#define root l,r,rt
#define mst(a,b) memset((a),(b),sizeof(a))
#define pii pair<ll,ll>
#define mk(x,y) make_pair(x,y)
const int maxn=1e5+8;
const int ub=1e6;
ll A,B;
int n,k;
ll h[maxn];
ll tmp[31];
/*
題目意思不再描述,感覺如果不是空間限制就是個線段樹的題目,
但是空間開不了這麼大,一種做法是動態開點,
還有一種就是分治處理,分治的樣子和線段樹差不多,
詳見程式碼。
*/
ll f(int nn,int s,int t,ll add){
if(nn==0){
int pos1=lower_bound(h,h+k,h[s])-h;
int pos2=upper_bound(h,h+k,h[s])-h;
return 1LL*(pos2-pos1)*B;
}
int pos=upper_bound(h+s,h+t,tmp[nn-1]+add)-h-s;///
///while(pos+1<t&&h[pos]==h[pos+1]) pos++;
if(pos==t-s){
ll val=f(nn-1,s,t,add)+A;
val=min(val,1LL*(t-s)*B*tmp[nn]);
return val;
}else if(pos==0){
ll val=f(nn-1,s,t,add+tmp[nn-1])+A;
val=min(val,1LL*(t-s)*B*tmp[nn]);
return val;
}
else return min(1LL*(t-s)*B*tmp[nn],f(nn-1,s,s+pos,add)+f(nn-1,s+pos,t,add+tmp[nn-1]));
}
int main(){
mst(h,0);
tmp[0]=1LL;rep(i,1,31) tmp[i]=tmp[i-1]*2LL;
cin>>n>>k>>A>>B;
rep(i,0,k) cin>>h[i];
sort(h,h+k);///
if(k==0) cout<<A<<'\n';
else cout<<f(n,0,k,0LL)<<'\n';
return 0;
}
第三題:(線段樹動態開點)
#include "bits/stdc++.h"
using namespace std;
typedef long long ll;
const int N = 1e5 + 10;
ll n,k,A,B;
map<int,int> mp;
struct Node {
Node *lson = nullptr;
Node *rson = nullptr;
int sum = 0;
} *root;
void update(Node *o,int l,int r,int x) {
o->sum++;
if(l == r) return;
int mid = (l + r) >> 1;
if(x <= mid) {
if(!o->lson) o->lson = new Node;
update(o->lson,l,mid,x);
} else {
if(!o->rson) o->rson = new Node;
update(o->rson,mid + 1,r,x);
}
}
int query(Node *o,int l,int r,int ql,int qr) {
if(ql <= l && qr >= r) return o->sum;
int mid = (l + r) >> 1;
int res = 0;
if(ql <= mid && o->lson) res += query(o->lson,l,mid,ql,qr);
if(qr > mid && o->rson) res += query(o->rson,mid + 1,r,ql,qr);
return res;
}
ll f(int l,int r) {
if(l == r) return mp.count(l) ? B * mp[l] : A;
int cnt = query(root,1,1 << n,l,r);
if(cnt == 0) return A;
int mid = (l + r) >> 1;
int len = r - l + 1;
ll sum = B * len * cnt;
return min(f(l,mid) + f(mid + 1,r),sum);
}
int main() {
cin >> n >> k >> A >> B;
root = new Node;
for(int i = 0;i < k;i++) {
int x;
cin >> x;
mp[x]++;
update(root,1,1 << n,x);
}
cout << f(1,1 << n) << endl;
return 0;
}
第四題(組合數學+退揹包DP):
#include<bits/stdc++.h>
using namespace std;
#define debug puts("YES");
#define rep(x,y,z) for(int (x)=(y);(x)<(z);(x)++)
#define ll long long
#define lrt int l,int r,int rt
#define lson l,mid,rt<<1
#define rson mid+1,r,rt<<1|1
#define root l,r,rt
#define mst(a,b) memset((a),(b),sizeof(a))
#define pii pair<int,int>
#define fi first
#define se second
#define mk(x,y) make_pair(x,y)
const int mod=1e9+7;
const int maxn=1e5+5;
const int ub=1e6;
const double inf=1e-4;
ll powmod(ll x,ll y){ll t; for(t=1;y;y>>=1,x=x*x%mod) if(y&1) t=t*x%mod; return t;}
ll gcd(ll x,ll y){return y?gcd(y,x%y):x;}
char s[maxn];
int len,cnt[52],q,x,y;
ll dp[maxn],g[maxn],ans[52][52];
int idx(char c){
if(c<='z'&&c>='a') return c-'a';
return 26+c-'A';
}
ll fac[maxn],inv[maxn];
void init(){
fac[0]=1;rep(i,1,maxn) fac[i]=fac[i-1]*i%mod;
inv[maxn-1]=powmod(fac[maxn-1],mod-2);
for(int i=maxn-2;i>=0;i--) inv[i]=inv[i+1]*(i+1)%mod;
}
ll C(ll p,ll q){
return fac[p]*inv[q]%mod*inv[p-q]%mod;
}
void Back(int x){
rep(k,0,x) g[k]=dp[k];
rep(k,x,len/2+1) g[k]=(dp[k]-g[k-x]+mod)%mod;
}
int main(){
init();
scanf("%s",s);len=strlen(s);///
rep(i,0,len) cnt[idx(s[i])]++;
mst(dp,0),mst(g,0),dp[0]=1;
rep(i,0,52) if(cnt[i]) for(int j=len/2;j>=cnt[i];j--)
(dp[j]+=dp[j-cnt[i]])%=mod;
mst(ans,0);///
rep(i,0,52) rep(j,i,52){
Back(cnt[i]);
if(i!=j) rep(k,cnt[j],len/2+1)
g[k]=(g[k]-g[k-cnt[j]]+mod)%mod;
ans[i][j]=g[len/2];
}
ll xishu=fac[len/2]*fac[len/2]%mod;
rep(i,0,52) xishu=xishu*inv[cnt[i]]%mod;
cin>>q;
rep(i,0,q){
cin>>x>>y;
x=idx(s[x-1]),y=idx(s[y-1]);
ll ret=max(ans[x][y],ans[y][x]);
ret=ret*2%mod*xishu%mod;
cout<<ret<<endl;
}
return 0;
}
第四題(樹狀陣列+DP+LCA):
#include<bits/stdc++.h>
using namespace std;
#define rep(x,y,z) for(int (x)=(y);(x)<(z);(x)++)
#define ll long long
#define mst(a,b) memset((a),(b),sizeof(a))
const int mod=1e9+7;
const int maxn=1e5+10;
const int ub=1e6;
const double inf=1e-4;
ll powmod(ll x,ll y){ll t; for(t=1;y;y>>=1,x=x*x%mod) if(y&1) t=t*x%mod; return t;}
ll gcd(ll x,ll y){return y?gcd(y,x%y):x;}
/*
題目大意:
給定一棵樹,和若干個詢問,
k,m,r和k個數,問把這k個點分成至多m組
且每組中的點集沒有父節點與子節點的關係,
其方案數有多少種。
題目分析:
這道題我是看了別人的思路才懂的,
果然還是自己太弱了呀。。。
先簡化問題,如果根是固定的如何考慮,
那麼觀察到m的資料範圍去考慮DP計數,
dp(i,j)代表i個數分成j組有多少種方案,
轉移方程:dp(i,j)=dp(i-1,j-1)+dp(i-1,j)*(j-f[i]),
其中f[i]代表的是i節點對於1根有多少個父節點,
因為這f[i]個父節點肯定安排在不同的集合中,
那麼根據DFS序性質,我們可以利用樹狀陣列統計父節點的個數,
但只能對於特定的根,如果根變換呢?
考慮路徑差,特定的點其到特定的根的路徑上的權重,
即樹上任意兩點之間路徑的權值和,我們利用LCA來輔助轉換。
所以就是對於每個查詢,我們不難統計出每個點的f[i],這樣狀態轉移方程的
條件就有了。
我的想法是直接按DFS再搜一遍,遇到其k個點之一就重新整理狀態陣列,
但是我看的這位博主另有想法,它直接把f陣列排序然後對這個陣列進行DP了,
DP的性質是無後效性,而子節點不會比父節點的f值來的大,所以對於
任意一個互斥對都滿足了更新順序。
最後一些細節就是滾動陣列,還有DP陣列開int再型別轉換取模優化下,
我開long long被T了。
*/
int n,q,x,y;
///前式鏈向星
vector<int> g[maxn];
int pl[maxn],pr[maxn],bit[maxn],tot;///深度
inline void refresh(int x,int d){
for(;x<maxn;bit[x]+=d,x+=x&-x);
}
inline int sum(int x){
int ret=0;for(;x;ret+=bit[x],x-=x&-x);return ret;
}
int st[maxn][20],dep[maxn];
inline void dfs(int u,int pre){
pl[u]=++tot;
dep[u]=dep[pre]+1;
st[u][0]=pre;rep(i,1,20) st[u][i]=st[st[u][i-1]][i-1];
for(int i=0;i<g[u].size();i++){
int v=g[u][i];
if(v==pre) continue;
dfs(v,u);
}
pr[u]=tot;
}
inline int lca(int u,int v){
if(u==v) return u;
if(dep[u]<dep[v]) swap(u,v);
for(int i=19;i>=0;i--) if(dep[st[u][i]]>=dep[v])
u=st[u][i];
if(u==v) return u;
for(int i=19;i>=0;i--) if(st[u][i]!=st[v][i])
u=st[u][i],v=st[v][i];
return st[u][0];
}
int dp[maxn];
int k,m,r,a[maxn],f[maxn],vis[maxn];
int main(){
scanf("%d%d",&n,&q);
rep(i,0,n-1){
scanf("%d%d",&x,&y);
g[x].push_back(y);
g[y].push_back(x);
}
tot=0;dfs(1,0);
rep(i,0,q){
scanf("%d%d%d",&k,&m,&r);
rep(i,1,k+1){
scanf("%d",&a[i]);
vis[a[i]]=1;
refresh(pl[a[i]],1);
refresh(pr[a[i]]+1,-1);
}
int tmp=sum(pl[r]);
rep(i,1,k+1){
int LCA=lca(r,a[i]);
f[i]=sum(pl[a[i]])+tmp-2*sum(pl[LCA])+vis[LCA]-1;///減去自己
}
rep(i,1,k+1){
vis[a[i]]=0;
refresh(pl[a[i]],-1);
refresh(pr[a[i]]+1,1);
}
if(f[k]>=m) {puts("0");continue;}
sort(f+1,f+1+k);
mst(dp,0),dp[0]=1;
rep(i,1,k+1) for(int j=min(i,m);j>=0;j--){
if(j<=f[i]) dp[j]=0;
else dp[j]=((ll)dp[j-1]+(ll)dp[j]*(j-f[i])%mod)%mod;
}
ll ans=0;rep(i,1,m+1) (ans+=dp[i])%=mod;
printf("%lld\n",ans);
}
return 0;
}
相關文章
- Codeforces Round #266 (Div. 2)解題報告
- Codeforces Round #537 (Div. 2)C Creative Snap (分治)
- Codeforces Round 976 (Div. 2) 題解
- Codeforces Round 983 (Div. 2) 題解
- Codeforces Round #956 (Div. 2)題解
- Codeforces Round 951 (Div. 2) 題解
- Codeforces Round 965 (Div. 2) 題解
- Codeforces Round #681 (Div. 2)E題解
- Codeforces Round 932 (Div. 2) DE 題解
- Educational Codeforces Round 93 (Rated for Div. 2)題解
- Codeforces Round #665 (Div. 2)A-C題解
- Codeforces Round #673 (Div. 2)(A-D)題解
- Codeforces Round #439 (Div. 2) A-C題解
- Codeforces Round #Pi (Div. 2) (ABCD題解)
- Codeforces Round 976 (Div. 2) 題解(A-E)
- Codeforces Round 893 (Div. 2)題解記錄
- Codeforces Round 892 (Div. 2)題解記錄
- Educational Codeforces Round 171 (Rated for Div. 2) 題解
- Codeforces Round #537 (Div. 2)B. Average Superhero Gang Power (貪心+暴力)
- Codeforces Round #186 (Div. 2) (ABCDE題解)
- Codeforces Round #105 (Div. 2) (ABCDE題解)
- Codeforces Round #200 (Div. 2) (ABCDE題解)
- Codeforces Round #313 (Div. 2) (ABCDE題解)
- Codeforces Round #323 (Div. 2) (ABCD題解)
- Codeforces Round #331 (Div. 2) (ABC題解)
- Codeforces Round 899 (Div. 2)題解記錄
- Codeforces Round 979 (Div. 2) (ABCD個人題解)
- Educational Codeforces Round 168 (Rated for Div. 2) 題解
- Codeforces Round 986 (Div. 2)題解記錄(A~D)
- Codeforces Round 987 (Div. 2)題解記錄(A~D)
- Codeforces Round 984 (Div. 3) 題解
- Codeforces Round 962 (Div. 3) 題解
- Codeforces Round 946 (Div. 3) 題解
- Codeforces Round #646 (Div. 2)【C. Game On Leaves 題解】GAM
- Codeforces Round #319 (Div. 2) (ABCE題解)
- Codeforces Round #315 (Div. 2) (ABCD題解)
- Codeforces Round 975 (Div. 2)題解記錄(A,B,E)
- Codeforces Round #639 (Div. 2)